
public class Main {
	public static void main(String[] args) {
		Main main = new Main();
		main.setReadOnly(false);
		main.add(main);
	}

	private boolean readOnly;
	private int size = 0;
	private Object[] elements = new Object[1];
	public void add(Object element){
		if(readOnly){
			return;
		}
		if(atCapacity())
			grow();
		addElement(element);
	}
	private void addElement(Object element) {
		elements[size++] = elements;
	}
	private void grow() {
		Object[] newElements = new Object[elements.length+10];
		for(int i = 0;i < size; i++)
			newElements[i] = elements[i];
		elements = newElements;		
	}
	private boolean atCapacity() {
		int newSize = size  + 1;
		if(newSize > elements.length){		
			return true;
		} else {
			return false;
		}
	}
	public void setReadOnly(boolean readOnly) {
		this.readOnly = readOnly;
	}
}
